#include "ds1000zlib.h"

#define NV_BUF_SIZE	(0x2000)
#define NVRAM_TOTAL	(0x80000)
#define I2C_TOTAL	(0x800)

static void FatalShow(int NumBeep)
{
Sleep(200);
for( ;;){
 int BeepCnt;
 for(BeepCnt = NumBeep; BeepCnt > 0; BeepCnt--){
   Sleep(500);
   Beeper_Generate(1000, 100);
 } 
 Sleep(2000);
}  
}


static int CopyFiles(char *SrcName, char *DstName, void *Buffer)
{
FILE *f;
int Handle;
int Length;
Handle = uffs_open(SrcName, 0);
if(Handle <0){
  	return(1);
}
Length = uffs_read(Handle, Buffer,   NV_BUF_SIZE);
uffs_close(Handle);  
if(Length > 0){
   f = usb_fopen(DstName, "w");
   if(f != NULL){
	write(f, Buffer, Length);
	usb_fclose(f);
   }
}
return(0);
}
		     
void ThreadBody(void)
{
FILE *f;
void *Buffer;
int i;
Beeper_Generate(50, 100);
Beeper_Generate(1000, 100);
Sleep(200);
Buffer = malloc(NV_BUF_SIZE);
if(NULL == Buffer) {
  FatalShow(1);
}
Sleep(200);
Beeper_Generate(400, 200);
f = usb_fopen("D:/DS1KZ_NVRAM.BIN", "w");
if(NULL == f){
  FatalShow(2);
} 
Sleep(200);
Beeper_Generate(500, 200);
for(i=0;i < 0x80000; i+=NV_BUF_SIZE){
  SPI2_NVRAM_Read(i, Buffer, NV_BUF_SIZE);
  write(f, Buffer, NV_BUF_SIZE);
  Beeper_Generate(1000 + i / NV_BUF_SIZE, 10);
}
usb_fclose(f);
Sleep(200);

Beeper_Generate(600, 200);
f = usb_fopen("D:/DS1KZ_I2C.BIN", "w");
if(NULL == f){
  FatalShow(2);
} 
Sleep(200);
Beeper_Generate(500, 200);
I2C_ReadNvram(Buffer, I2C_TOTAL);
write(f, Buffer, I2C_TOTAL);
usb_fclose(f);
Sleep(200);

CopyFiles("/sys/OptionPara.bin", "D:/OPTIONPARA.BIN", Buffer);
CopyFiles("/sys/OptionData.bin", "D:/OPTIONDATA.BIN", Buffer);
CopyFiles("/sys/CalData.bin", "D:/CALDATA.BIN", Buffer);
CopyFiles("/sys/_SYS_REG_CFG_0417.cfg", "D:/SYSREG.cfg", Buffer);
CopyFiles("/sys/lxi_web.hex", "D:/LXI_WEB.cfg", Buffer);

free(Buffer);
Beeper_Generate(80, 3000);
// infinite loop
for(;;){
Sleep(200);
Beeper_Generate(50, 100);
Sleep(200);
Beeper_Generate(1000, 100);
}

}

int PluginMain(void)
{
task_template_struct Descr;
Descr.TASK_TEMPLATE_INDEX = 0;
Descr.TASK_ADDRESS = (void *)ThreadBody;
Descr.TASK_STACKSIZE = 0x4000;
Descr.TASK_PRIORITY = 8;
Descr.TASK_NAME = "bkup";
Descr.TASK_ATTRIBUTES = 4;
Descr.CREATION_PARAMETER = 0;
Descr.DEFAULT_TIME_SLICE = 0;
task_create(0, 0, &Descr);
// Simple return, no free memory!
return(0);  
}
